Bug 675478 - Review Request: gprbuild - Ada project builder
Summary: Review Request: gprbuild - Ada project builder
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Mikhail Kulemin
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 675388 688986
Blocks: 675557
TreeView+ depends on / blocked
 
Reported: 2011-02-05 22:09 UTC by Pavel Zhukov
Modified: 2012-03-06 07:09 UTC (History)
4 users (show)

Fixed In Version: gprbuild-2010-7.fc15
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2011-03-18 20:06:21 UTC
mihkulemin: fedora-review+


Attachments (Terms of Use)

Description Pavel Zhukov 2011-02-05 22:09:24 UTC
Spec URL: http://landgraf.fedorapeople.org/packages/requested/gprbuild/gprbuild.spec
SRPM URL: http://landgraf.fedorapeople.org/packages/requested/gprbuild/gprbuild-2010-2.fc14.src.rpm

Description: 
GPRbuild is an advanced software tool designed to help automate the construction of multi-language systems. It removes complexity from multi-language development by allowing developers to quickly and easily compile and link software written in a combination of languages including Ada, Assembler, C, C++, and Fortran. Easily extendable by users to cover new toolchains and languages it is primarily aimed at projects of all sizes organized into subsystems and libraries and is particularly well-suited for compiled languages.

koji: Unavailable (see depend tag)
mock: ok

Comment 1 Pavel Zhukov 2011-02-05 22:10:24 UTC

-- 
Fedora Bugzappers volunteer triage team
https://fedoraproject.org/wiki/BugZappers

Comment 2 Pavel Zhukov 2011-02-06 16:49:15 UTC

-- 
Fedora Bugzappers volunteer triage team
https://fedoraproject.org/wiki/BugZappers

Comment 3 Pavel Zhukov 2011-02-06 21:22:57 UTC
Spec URL:
http://landgraf.fedorapeople.org/packages/requested/gprbuild/gprbuild.spec
SRPM URL:
http://landgraf.fedorapeople.org/packages/requested/gprbuild/gprbuild-2010-3.fc14.src.rpm

new build (fixed gcc regexp for non-English gcc -v output)




-- 
Fedora Bugzappers volunteer triage team
https://fedoraproject.org/wiki/BugZappers

Comment 4 Pavel Zhukov 2011-02-07 14:36:58 UTC
Fixed issue with gcc-4.6.0 (rawhide)
SPEC:
http://landgraf.fedorapeople.org/packages/requested/gprbuild/gprbuild.spec
SRPM:
http://landgraf.fedorapeople.org/packages/requested/gprbuild/gprbuild-2010-3.fc14.src.rpm

mock: ok



-- 
Fedora Bugzappers volunteer triage team
https://fedoraproject.org/wiki/BugZappers

Comment 5 Mikhail Kulemin 2011-02-28 08:54:22 UTC
I`ll review it.

Comment 7 Pavel Zhukov 2011-03-10 13:43:27 UTC
Koji ok
http://koji.fedoraproject.org/koji/taskinfo?taskID=2900576

Comment 8 Mikhail Kulemin 2011-03-10 16:57:48 UTC
Found xmlada package only in f15 repo. Do you plan to build xmlada and gprbuild for f14?

Comment 9 Pavel Zhukov 2011-03-10 17:30:46 UTC
No, for F15 and later



-- 
Fedora Bugzappers volunteer triage team
https://fedoraproject.org/wiki/BugZappers

Comment 10 Mikhail Kulemin 2011-03-11 08:46:25 UTC
Doc files locate in /usr/share/doc/gprbuild and /usr/share/doc/gprbuild-2010. The most common location is /usr/share/doc/%{name}-%{version}. To my mind you should use the only location for docs.b

Comment 12 Mikhail Kulemin 2011-03-11 11:19:50 UTC
* The other case is about documentation files: .info file located in docdir. Using archives in /usr/share/info is a more proper way. 

* There are many documentation sources in docdir - it is not comfortable for user. You can just delete doc sources or move them to -devel package if appropriate.

Comment 13 Pavel Zhukov 2011-03-11 12:40:48 UTC
Fixed doc directory

Comment 14 Pavel Zhukov 2011-03-11 14:01:32 UTC
add doc package
http://koji.fedoraproject.org/koji/taskinfo?taskID=2904209

Comment 16 Mikhail Kulemin 2011-03-18 07:56:15 UTC
[mih@localhost result]$ rpmlint gprbuild-2010-7.fc15.x86_64.rpm 
gprbuild.x86_64: W: spelling-error %description -l en_US multi -> mulch, mufti
gprbuild.x86_64: W: spelling-error %description -l en_US extendable -> expendable, extend able, extend-able
gprbuild.x86_64: W: spelling-error %description -l en_US toolchains -> tool chains, tool-chains, toolmaking
gprbuild.x86_64: W: executable-stack /usr/bin/gprclean
gprbuild.x86_64: W: executable-stack /usr/libexec/gprbuild/gprbind
gprbuild.x86_64: W: executable-stack /usr/bin/gprconfig
gprbuild.x86_64: W: executable-stack /usr/libexec/gprbuild/gprlib
gprbuild.x86_64: W: executable-stack /usr/bin/gprbuild
gprbuild.x86_64: W: spurious-executable-perm /usr/share/doc/gprbuild-2010/README
gprbuild.x86_64: W: spurious-executable-perm /usr/share/doc/gprbuild-2010/COPYING
gprbuild.x86_64: W: spurious-executable-perm /usr/share/doc/gprbuild-2010/CHANGE_160803
gprbuild.x86_64: W: no-manual-page-for-binary gprclean
gprbuild.x86_64: W: no-manual-page-for-binary gprconfig
gprbuild.x86_64: W: no-manual-page-for-binary gprbuild
1 packages and 0 specfiles checked; 0 errors, 14 warnings.

Some comments:
To fix: exec perm on README, COPYING, CHANGE_160803 files
To ignore: spelling, man pages, executable stack is normal for Ada programs too.

Comment 17 Pavel Zhukov 2011-03-18 08:14:35 UTC
fixed tab and spaces. Fixed summary, Fixed perms http://landgraf.fedorapeople.org/packages/requested/gprbuild/gprbuild-2010-7.fc14.src.rpm

Comment 18 Mikhail Kulemin 2011-03-18 08:30:07 UTC
MUST: rpmlint must be run on every package.
->OK, There're executable-stack and spelling warnings. Executable-stack is normal for Ada.

MUST: The package must be named according to the Package Naming Guidelines.
->OK

MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.
->OK

MUST: The package must meet the Packaging Guidelines.
->OK

MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.
->OK GPLv2+

MUST: The License field in the package spec file must match the actual license.
->OK

MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
->OK

MUST: The spec file must be written in American English.
->OK

MUST: The spec file for the package MUST be legible.
->OK

MUST: The sources used to build the package must match the upstream source, as provided in the spec URL.
->OK, md5sum = ca3dd79405d08d04744b1356cf3c71cc Direct download unavailable.

MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
->OK

MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch.
->N/A

MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional.
->OK

MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
->N/A

MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
->N/A

MUST: Packages must NOT bundle copies of system libraries.
->OK

MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
->N/A

MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
>OK

MUST: A Fedora package must not list a file more than once in the spec file's %files listings.
->OK

MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line.
->OK

MUST: Each package must consistently use macros.
->OK

MUST: The package must contain code, or permissable content.
->OK

MUST: Large documentation files must go in a -doc subpackage.
->N/A

MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
->OK

MUST: Header files must be in a -devel package.
->OK

MUST: Static libraries must be in a -static package.
->N/A

MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.
->N/A

MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release}.
->OK

MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
->OK

MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section.
->N/A

MUST: Packages must not own files or directories already owned by other packages.
->OK

MUST: All filenames in rpm packages must be valid UTF-8.
->OK

 

== ADA GuideLines

Ada code in Fedora MUST be compiled using GNAT
-> OK

All packages that contain Ada code MUST have "BuildRequires: fedora-gnat-project-common"
-> OK

Ada library packages MUST have a -devel subpackage containing all the files that are necessary for compilation of code that uses the library.
-> N/A

The -devel package MUST NOT contain all the source files of the library, only those that are necessary for compilation of code that uses the library.
-> OK

The -devel package MUST NOT contain any makefiles or other files that are only used for recompiling the library.
-> OK

The -devel package MUST NOT contain any *.o files.
-> OK

The -devel package MUST contain one or more GNAT project files to be imported by other projects that use the library.
-> N/A Not a library

Project files MUST be architecture-independent.
-> N/A

Project files MUST NOT contain hard-coded directory names
-> N/A

Project files MUST have an Externally_Built attribute equal to "true".
-> N/A

Ada source files in -devel packages (*.ads and *.adb) MUST be placed in the %{_includedir}
-> N/A

Ada library information files (*.ali) MUST be placed in a subdirectory of %{_libdir}, for example %{_libdir}/%{name}
-> N/A

GNAT projects files (*.gpr) MUST be placed in the %{_GNAT_project_dir} directory
-> N/A

So this package is 

APPROVED.

Comment 19 Pavel Zhukov 2011-03-18 08:52:44 UTC
New Package SCM Request
=======================
Package Name: gprbuild
Short Description: Ada project builder
Owners: landgraf
Branches: f15
InitialCC:

Comment 20 Jason Tibbitts 2011-03-18 17:49:06 UTC
Git done (by process-git-requests).

Comment 21 Pavel Zhukov 2011-03-18 18:08:19 UTC

-- 
Fedora Bugzappers volunteer triage team
https://fedoraproject.org/wiki/BugZappers

Comment 22 Fedora Update System 2011-03-18 18:31:07 UTC
gprbuild-2010-7.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/gprbuild-2010-7.fc15

Comment 23 Fedora Update System 2011-03-23 05:06:23 UTC
gprbuild-2010-7.fc15 has been pushed to the Fedora 15 stable repository.

Comment 24 Pavel Zhukov 2011-11-07 12:38:47 UTC
Package Change Request
======================
Package Name: grpbuild
New Branches: el6
Owners: landgraf
InitialCC:

Comment 25 Gwyn Ciesla 2011-11-07 13:19:25 UTC
Git done (by process-git-requests).

Corrected pkg name.

Comment 26 Pavel Zhukov 2012-03-04 10:55:39 UTC
Package Change Request
======================
Package Name: gprbuild
New Branches: el6
Owners: landgraf

Comment 27 Jens Petersen 2012-03-06 07:09:07 UTC
There is already a EL-6 branch.  So I am not sure what you want?


Note You need to log in before you can comment on or make changes to this bug.